shell: syncronize ash_test/run-all and hush_test/run-all a bit
authorDenys Vlasenko <vda.linux@googlemail.com>
Thu, 6 Jul 2017 15:59:25 +0000 (17:59 +0200)
committerDenys Vlasenko <vda.linux@googlemail.com>
Thu, 6 Jul 2017 15:59:25 +0000 (17:59 +0200)
Signed-off-by: Denys Vlasenko <vda.linux@googlemail.com>
shell/ash_test/run-all
shell/hush_test/run-all

index 8dfdddd9fa2ed68040e80fef416eca17afc14f74..983e6d184c6106aabfe48ea86253a8607b06ae9f 100755 (executable)
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-TOPDIR=$PWD
+TOPDIR=`pwd`
 
 test -x ash || {
     echo "No ./ash - creating a link to ../../busybox"
@@ -10,67 +10,73 @@ test -x printenv || gcc -O2 -o printenv printenv.c || exit $?
 test -x recho    || gcc -O2 -o recho    recho.c    || exit $?
 test -x zecho    || gcc -O2 -o zecho    zecho.c    || exit $?
 
-PATH="$PWD:$PATH" # for ash and recho/zecho/printenv
+PATH="`pwd`:$PATH" # for ash and recho/zecho/printenv
 export PATH
 
-THIS_SH="$PWD/ash"
+THIS_SH="`pwd`/ash"
 export THIS_SH
 
 do_test()
 {
-    test -d "$1" || return 0
-#   echo do_test "$1"
-    # $1 but with / replaced by # so that it can be used as filename part
-    noslash=`echo "$1" | sed 's:/:#:g'`
-    (
-    cd "$1" || { echo "cannot cd $1!"; exit 1; }
-    for x in run-*; do
-       test -f "$x" || continue
-       case "$x" in
-           "$0"|run-minimal|run-gprof) ;;
-           *.orig|*~) ;;
-           #*) echo $x ; sh $x ;;
-           *)
-           echo -n "$1/$x: "
-           sh "$x" >"$TOPDIR/$noslash-$x.fail" 2>&1 && \
-           { echo "ok"; rm "$TOPDIR/$noslash-$x.fail"; } || echo "fail";
-           ;;
-       esac
-    done
-    # Many bash run-XXX scripts just do this,
-    # no point in duplication it all over the place
-    for x in *.tests; do
-       test -x "$x" || continue
-       name="${x%%.tests}"
-       test -f "$name.right" || continue
-       echo -n "$1/$x: "
-       {
-           "$THIS_SH" "./$x" >"$name.xx" 2>&1
-           diff -u "$name.xx" "$name.right" >"$TOPDIR/$noslash-$x.fail" \
-           && rm -f "$name.xx" "$TOPDIR/$noslash-$x.fail"
-       } && echo "ok" || echo "fail"
-    done
-    )
+       test -d "$1" || return 0
+       d=${d%/}
+#      echo Running tests in directory "$1"
+       # $1 but with / replaced by # so that it can be used as filename part
+       noslash=`echo "$1" | sed 's:/:#:g'`
+       (
+       cd "$1" || { echo "cannot cd $1!"; exit 1; }
+       for x in run-*; do
+               test -f "$x" || continue
+               case "$x" in
+                       "$0"|run-minimal|run-gprof) ;;
+                       *.orig|*~) ;;
+                       #*) echo $x ; sh $x ;;
+                       *)
+                       echo -n "$1/$x:"
+                       sh "$x" >"$TOPDIR/$noslash-$x.fail" 2>&1 && \
+                       { { echo " ok"; rm "$TOPDIR/$noslash-$x.fail"; } || echo " fail"; }
+                       ;;
+               esac
+       done
+       # Many bash run-XXX scripts just do this,
+       # no point in duplication it all over the place
+       for x in *.tests; do
+               test -x "$x" || continue
+               name="${x%%.tests}"
+               test -f "$name.right" || continue
+#              echo Running test: "$x"
+               echo -n "$1/$x:"
+               {
+                       "$THIS_SH" "./$x" >"$name.xx" 2>&1
+                       diff -u "$name.xx" "$name.right" >"$TOPDIR/$noslash-$x.fail" \
+                       && rm -f "$name.xx" "$TOPDIR/$noslash-$x.fail"
+               } && echo " ok" || echo " fail"
+               done
+       )
 }
 
-# main part of this script
+# Main part of this script
 # Usage: run-all [directories]
 
+ret=0
+
 if [ $# -lt 1 ]; then
-    # All sub directories
-    modules=`ls -d ash-*`
-    # If you want to test ash against hush testsuite
-    # (have to copy hush_test dir to current dir first):
-    #modules=`ls -d ash-* hush_test/hush-*`
+       # All sub directories
+       modules=`ls -d ash-*`
+       # If you want to test ash against hush testsuite
+       # (have to copy hush_test dir to current dir first):
+       #modules=`ls -d ash-* hush_test/hush-*`
 
-    for module in $modules; do
-       do_test $module
-    done
+       for module in $modules; do
+               do_test $module || ret=1
+       done
 else
-    while [ $# -ge 1 ]; do
+       while [ $# -ge 1 ]; do
        if [ -d $1 ]; then
-           do_test $1
+               do_test $1 || ret=1
        fi
        shift
-    done
+       done
 fi
+
+exit ${ret}
index 837b3f7da100d64b585ffd1a7cd3e048b578b259..1dd0edc39bd49f412482b9b2356a28cd35ff02a4 100755 (executable)
@@ -9,6 +9,8 @@ unset LC_NUMERIC
 unset LC_TIME
 unset LC_ALL
 
+TOPDIR=`pwd`
+
 if test ! -x hush; then
        if test ! -x ../../busybox; then
                echo "Can't run tests. Put hush binary into this directory (`pwd`)"
@@ -38,6 +40,8 @@ do_test()
        test -d "$1" || return 0
        d=${d%/}
 #      echo Running tests in directory "$1"
+       # $1 but with / replaced by # so that it can be used as filename part
+       noslash=`echo "$1" | sed 's:/:#:g'`
        (
        tret=0
        cd "$1" || { echo "cannot cd $1!"; exit 1; }
@@ -49,34 +53,35 @@ do_test()
                        #*) echo $x ; sh $x ;;
                        *)
                        echo -n "$1/$x:"
-                       sh "$x" >"../$1-$x.fail" 2>&1 && \
-                       { { echo " ok"; rm "../$1-$x.fail"; } || echo " fail"; }
+                       sh "$x" >"$TOPDIR/$noslash-$x.fail" 2>&1 && \
+                       { { echo " ok"; rm "$TOPDIR/$noslash-$x.fail"; } || echo " fail"; }
                        ;;
                esac
        done
        # Many bash run-XXX scripts just do this,
        # no point in duplication it all over the place
        for x in *.tests; do
-       test -x "$x" || continue
-       name="${x%%.tests}"
-       test -f "$name.right" || continue
-#      echo Running test: "$x"
-       echo -n "$1/$x:"
-       (
-               "$THIS_SH" "./$x" >"$name.xx" 2>&1
-               r=$?
-               # filter C library differences
-               sed -i \
-                       -e "/: invalid option /s:'::g" \
-                       "$name.xx"
-               test $r -eq 77 && rm -f "../$1-$x.fail" && exit 77
-               diff -u "$name.xx" "$name.right" >"../$1-$x.fail" && rm -f "$name.xx" "../$1-$x.fail"
-       )
-       case $? in
-               0)  echo " ok";;
-               77) echo " skip (feature disabled)";;
-               *)  echo " fail"; tret=1;;
-       esac
+               test -x "$x" || continue
+               name="${x%%.tests}"
+               test -f "$name.right" || continue
+#              echo Running test: "$x"
+               echo -n "$1/$x:"
+               (
+                       "$THIS_SH" "./$x" >"$name.xx" 2>&1
+                       r=$?
+                       # filter C library differences
+                       sed -i \
+                               -e "/: invalid option /s:'::g" \
+                               "$name.xx"
+                       test $r -eq 77 && rm -f "$TOPDIR/$noslash-$x.fail" && exit 77
+                       diff -u "$name.xx" "$name.right" >"$TOPDIR/$noslash-$x.fail" \
+                       && rm -f "$name.xx" "$TOPDIR/$noslash-$x.fail"
+               )
+               case $? in
+                       0)  echo " ok";;
+                       77) echo " skip (feature disabled)";;
+                       *)  echo " fail"; tret=1;;
+               esac
        done
        exit ${tret}
        )
@@ -92,7 +97,7 @@ if [ $# -lt 1 ]; then
        modules=`ls -d hush-*`
 
        for module in $modules; do
-       do_test $module || ret=1
+               do_test $module || ret=1
        done
 else
        while [ $# -ge 1 ]; do